
; Use this script to create and installer for ComediClient 1.1 for Windows
; To compile the scrip:
; 1. ComediClient.exe and qt-mt.dll must be in the same directory as 
;    this script!
; 2. Run NullSoft Installer Compiler on the script
; 3. Enjoy the generated ComediClient-1.1-Installer.exe

;--------------------------------

; The name of the installer
Name "ComediClient 1.1 Installer"

; The file to write
OutFile "ComediClient-1.1-Installer.exe"

; The default installation directory
InstallDir "$PROGRAMFILES\ComediClient 1.1"

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\ComediClient 1.1" "Install_Dir"

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

uninstPage uninstConfirm
uninstPage instfiles
;--------------------------------

; The stuff to install
Section "ComediClient (required)" ;components page above, name is important

  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File ComediClient.exe
  File qt-mt3.dll
  File mingwm10.dll      
  
  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\ComediClient 1.1" "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ComediClient 1.1" "DisplayName" "ComediClient 1.1"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ComediClient 1.1" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ComediClient 1.1" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ComediClient 1.1" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

SectionEnd ; end the section


; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\ComediClient 1.1"
  CreateShortCut "$SMPROGRAMS\ComediClient 1.1\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\ComediClient 1.1\ComediClient 1.1.lnk" "$INSTDIR\ComediClient.exe" "" "$INSTDIR\ComediClient.exe" 0
  
SectionEnd

Section "Desktop Shortcut"
  CreateShortCut "$DESKTOP\ComediClient 1.1.lnk" "$INSTDIR\ComediClient.exe" "" "$INSTDIR\ComediClient.exe" 0
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\ComediClient 1.1"
  DeleteRegKey HKLM "SOFTWARE\ComediClient 1.1"

  ; Remove files and uninstaller
  Delete $INSTDIR\ComediClient.exe
  Delete $INSTDIR\qt-mt3.dll
  Delete $INSTDIR\mingwm10.dll
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\ComediClient 1.1\Uninstall.lnk"
  Delete "$SMPROGRAMS\ComediClient 1.1\ComediClient 1.1.lnk"
  Delete "$DESKTOP\ComediClient 1.1.lnk"

  ; Remove directories used
  RMDir "$SMPROGRAMS\ComediClient 1.1"
  RMDir $INSTDIR

SectionEnd


; --------------------------------
; .onInit function -- make sure the installer is not already running
Function .onInit
 System::Call 'kernel32::CreateMutexA(i 0, i 0, t "ComediClientInstaller") i .r1 ?e'
 Pop $R0
 
 StrCmp $R0 0 +3
   MessageBox MB_OK|MB_ICONEXCLAMATION "The installer is already running."
   Abort
FunctionEnd


