#include "ComediDevice.h"



void comediDeviceFromLE(struct ComediDevice *dev, unsigned n_devices)
{
  for (; n_devices--; ++dev) {
    le_to_dw(&dev->minor);
    le_to_dw(&dev->versionCode);
    le_to_dw(&dev->nSubdevs);
    for (unsigned i = 0; i < dev->nSubdevs; ++i) {
      ComediSubDevice *sd = &dev->subdev[i];
      le_to_dw(&sd->minor);
      le_to_dw(&sd->id);
      le_to_dw(&sd->type);
      le_to_dw(&sd->nChans);
      le_to_dw(&sd->maxdata);
      le_to_dw(&sd->nRanges);
      for (unsigned j = 0; j < sd->nRanges; ++j) {
        ComediRange *r = &sd->range[j];
        le_to_dw(&r->id);
      }
    }
  }
}

void comediDeviceToLE(struct ComediDevice *dev, unsigned n_devices)
{
  for (; n_devices--; ++dev) {
    for (unsigned i = 0; i < dev->nSubdevs; ++i) {
      ComediSubDevice *sd = &dev->subdev[i];
      for (unsigned j = 0; j < sd->nRanges; ++j) {
        ComediRange *r = &sd->range[j];
        dw_to_le(&r->id);
      }
      dw_to_le(&sd->minor);
      dw_to_le(&sd->id);
      dw_to_le(&sd->type);
      dw_to_le(&sd->nChans);
      dw_to_le(&sd->maxdata);
      dw_to_le(&sd->nRanges);
    }
    dw_to_le(&dev->minor);
    dw_to_le(&dev->versionCode);
    dw_to_le(&dev->nSubdevs);
  }
  
}
