#include "Protocol.h"

#include <string.h>
#if defined(UNIX) || defined(LINUX) || !defined(WIN32)
#  include <sys/types.h>
#  include <sys/socket.h>
#else 
/* windows headers */
#  include <winsock.h>
#  define MSG_NOSIGNAL 0
#endif


void Protocol::SendOK(int sock) 
{
  int protolen = ::strlen(Protocol::OKText);
  ::send(sock, Protocol::OKText, protolen, MSG_NOSIGNAL);
  ::send(sock, "\n", 1, MSG_NOSIGNAL);
}

void Protocol::SendError(int sock, const char *msg)
{
  int protolen = ::strlen(Protocol::ErrorText);
  int len = ::strlen(msg);
  ::send(sock, Protocol::ErrorText, protolen, MSG_NOSIGNAL);
  ::send(sock, " ", 1, MSG_NOSIGNAL); 
  ::send(sock, msg, len, MSG_NOSIGNAL);
  if (!len || msg[len-1] != '\n') ::send(sock, "\n", 1, MSG_NOSIGNAL);
}

  // text based messages
const char * const Protocol::GetComediDevices =  "get comedi devices";
const char * const Protocol::YouAreADataThread = "hey foo', you are a data thread.  i have a key to prove it: "; // key
const char * const Protocol::StartACQ = "hook me up bigtime: "; // CID range aref hz bitfieldChans(optional for bitfield)
const char * const Protocol::WriteData = "yo check dis: "; // CID data range aref bitfieldChans(optional for bitfield)
const char * const Protocol::ReadData = "yo gimme dem duckets: "; // CID range aref bitfieldChans(optional for bitfield)
const char * const Protocol::DIOConfig = "dioconfig: ";  // CID input_output(input is 0 output is 1) mask(optional, if we have a mask use that as the list of channels to configure rather than CID.chan)

const char * const Protocol::GetVersion = "version";  // no params
const char * const Protocol::GetDIOConfig = "getdioconfig"; // CID
const char * const Protocol::Noop = "noop"; // no params

const char * const Protocol::ErrorText = "ERROR: ";
const char * const Protocol::OKText = "OK";

// Port 3335
const unsigned short Protocol::DefaultPort = 3335;

// version number is 2
const unsigned int Protocol::Version = 2;
