#ifndef CID_H
#define CID_H

#define MAX_CHANS  ( (0x1<<8) )
#define MAX_RANGES ( (0x1<<8) )
#define MAX_SUBDEVS ( (0x1<<4) )

#include "ArchDefs.h" /* for PACKED, et al */

#ifdef __cplusplus
extern "C" {
#endif

  /** A struct that represents a unique dev/subdev/channel combo to locate
      the precise channel we are working with on a system. This structure
      is readily represented as an unsigned short for fast serialization. */
  struct CID
  {
    unsigned dev    : 4;
    unsigned subdev : 4;
    unsigned chan   : 8;    

#ifdef __cplusplus
    CID(unsigned short fromNum = 0) { *this = fromNum; }
    
    /** Convert an unsigned 16-bit to a CID by just copying the memory. */
    CID & operator=(unsigned short rhs) 
    {
      *this = *reinterpret_cast<const CID *>(&rhs);
      return *this;
    }

    /** Convert this into an unsigned short by just copying the memory */
    operator unsigned short() const 
    { 
      return *reinterpret_cast<const unsigned short *>(this);
    }
#endif    
  } PACKED;

#ifndef __cplusplus
  typedef struct CID CID;
#endif

#ifdef __cplusplus
}
#endif

#endif
