#ifndef Protocol_H
#define Protocol_H


// the client/server protocol we are using
namespace Protocol
{

  extern const unsigned int Version;

  // 3335
  extern const unsigned short DefaultPort;

  // text based messages

  // the following commands supported by ALL server versions
  extern const char * const GetComediDevices;
  extern const char * const YouAreADataThread; // key
  extern const char * const StartACQ; // CID range aref hz bitfieldChans(optional for bitfield)
  extern const char * const WriteData; // CID data range aref bitfieldChans(optional for bitfield)
  extern const char * const ReadData; // CID range aref bitfieldChans(optional for bitfield)
  extern const char * const DIOConfig; // CID input_output(input is 0 output is 1) mask(optional, if we have a mask use that as the list of channels to configure rather than CID.chan)


  // command to query server version -- works on version 2 or above of server
  extern const char * const GetVersion; ///< query the size version of the server -- safeguard against incompatible client/server versions -- note not all server versions support this command (version 2 or above)

  /// command to query current dio config.. params: CID ; version 2 or above
  extern const char * const GetDIOConfig; 

  /// command that sends a noop and expects an ok response; version 2 or above
  extern const char * const Noop;

  // reply test from server (all versions)
  extern const char * const ErrorText;
  extern const char * const OKText;

  extern void SendError(int sock, const char *msg);
  extern void SendOK(int sock);
};


#endif
