#ifndef ProbeComedi_H
#define ProbeComedi_H

#include "ComediDevice.h"

#include <map>

typedef std::map<unsigned, ComediDevice> ComediDeviceMap;
typedef std::map<unsigned, void *> ComediHandleMap;

/** Probes all comedi devices from [start, end] and puts any found
    in the map from minor -> ComediDevice
    also puts their handles in handles_out which is 
    minor -> handle (the void * is really a comedi_t) */
extern void ProbeDevices(ComediDeviceMap & devs_out, 
                         ComediHandleMap & handles_out, 
                         unsigned start = 0, unsigned end = 15, 
                         bool verbose = true);
extern void CloseProbedHandles(const ComediHandleMap & handles);
#endif
